/**
* Контроллер-сборщик данных (к проекту http://smartliving.ru/)
* Platform: Arduino UNO R3 + EthernetShield W5100
* IDE: Arduino 1.0.1
* Подключение датчиков температуры DS18x20 по схеме с нормальным питанием (пример http://sourceforge.net/apps/trac/arduios/wiki/owmon)
* данные (зеленый провод со схемы по ссылке указанной выше) подключаем на D2
* ВНИМАНИЕ! Для того чтобы у Вас заработало получение данных с детчиков температуры, нужно прописать адреса ваших датчиков (ниже по коду)
*
* Остальные датчики:
Digital 8 - Красный светодиод Сигнализирует что передача данных не удаась
* Digital 9 - Зеленый свнтодиод 
* 10-й, 11-й, 12-й, 13-й зарезервированы для общения с сетевым чипом по протоколу SPI
* 4-й зарезервирован для обращения к SD-модулю
* 2-й для обработки прерываний сетевого чипа ????
Digital 2 pin Arduino (куда подключен выход с шины датчиков DS18X20
analogInPin = A0; - считыватель показаний электро счетчика
Digital 9 - dht11
*
*
**/
#include <Ethernet.h>
#include <SPI.h>
#include <OneWire.h>
#include <DallasTemperature.h>
//#include <math.h>
#include "DHT.h"
#include <BMP085.h>
#include <Wire.h> 
#include <LiquidCrystal.h>

BMP085 dps = BMP085();  

// MAC-адрес нашего устройства
byte mac[] = { 0xDE, 0xAD, 0xBE, 0xEF, 0xFE, 0xED };
IPAddress ip(192,168,1,177);

// select the pins used on the LCD panel
LiquidCrystal lcd(8, 9, 4, 5, 6, 7);

//byte subnet[] = { 255, 255, 255, 0 };
//byte gateway[] = { 192, 168, 1, 1 };
//byte dns_server[] = { 192, 168, 1, 1 };
// ip-адрес удалённого сервера
//byte server[] = { 192, 168, 1, 201 };
EthernetServer server(80);


// Pin controller for connection data pin DS18S20
#define ONE_WIRE_BUS 2 // Digital 2 pin Arduino (куда подключен выход с шины датчиков DS18X20
#define TEMPERATURE_PRECISION 9
#define DHTPIN 3

#define DHTTYPE DHT11   // DHT 11 

DHT dht(DHTPIN, DHTTYPE);

OneWire oneWire(ONE_WIRE_BUS);
DallasTemperature sensors(&oneWire);

unsigned long Blink1;
unsigned long Blink2;
 
 const int analogInPin = A0;
 const int ledPin = 9;
 const int ledPinError = 8; //Красный светодиод Сигнализирует что передача данных не удаась
const int MaxTimeOutPower = 30;

boolean debug=true;
DeviceAddress Termometers;

// Инициализация начальных значений
float tempC;
int old_temperature1=0;
int old_light=0;
char buf[80];
char ipbuff[16];
int PowerOst; 
float current_temp1;
long lastReadingTime = 0;
long lastReadingTimePower = 0;
float hum =0;
float tempIn;
long Pressure = 0;
int cur_pressure;
// ------------------------------------------------------------------------------------------------



/**************************************************************************************************
*/
void searchDevices() {
  if (debug) {Serial.println("Start search on 1-wire");}
   int numberOfDevices = sensors.getDeviceCount();
   if (debug) {Serial.print("Searched 1-wire units: ");}
   if (debug) {Serial.println(numberOfDevices);}
  // sensors.begin();
   
   for(int i=0;i<numberOfDevices; i++) {
      if(sensors.getAddress(Termometers, i))
      {
          if (debug) {Serial.print("Found device ");}
	  if (debug) {Serial.print(i, DEC);}
          if (debug) {Serial.print(" with address: ");}
          for (uint8_t i = 0; i < 8; i++) {
            if (Termometers[i] < 16) Serial.print("0");
              if (debug) {Serial.print(Termometers[i], HEX);}
          }

          if (debug) {Serial.print("Resolution actually set to: ");}
          if (debug) {Serial.print(sensors.getResolution(Termometers), DEC);} 
          if (debug) {Serial.println();}
          float tempC = sensors.getTempC(Termometers);
          if (debug) {Serial.print(tempC);}
          if (debug) {Serial.println("C");}
      
      } else {
            // not found
      }
    }
}




/**************************************************************************************************
*/

// ------------------------------------------------------------------------------------------------
void setup()
{
  // Для дебага будем выводить отладочные сообщения в консоль
  Serial.begin(9600);
  Serial.println("Start");
 
  Ethernet.begin(mac, ip);
  server.begin();
  Serial.print("server is at ");
  Serial.println(Ethernet.localIP());
  
  Serial.println("DHTxx test!");
  dht.begin();
  //Инициация датчика давления
  Wire.begin(); 
  dps.init();

// Настройки 1-wire 
  sensors.begin(); // Инициализация шины 1-wire (для датчиков температуры)
  searchDevices();

 //Ethernet.begin(mac, ip, dns_server, gateway, subnet); // Инициализируем Ethernet Shield

 pinMode(ledPin, OUTPUT); // Светодтод
 pinMode(ledPinError, OUTPUT); // Красный Светодтод
 digitalWrite(ledPinError, LOW);
 
 //////LCD
 lcd.begin(16, 2);              // start the library
 lcd.setCursor(0,0);
 lcd.print("Starting..."); // print a simple message   
 }


void GetTemp()
{
   // Перед каждым получением температуры надо ее запросить
  sensors.requestTemperatures();
  if (debug) {Serial.println("IN GetTemp");}
  int valid_sensor=0;

  delay(1000); // задержка в 1 сек.  


  // TEMP SENSOR 1 --------------------------------------
  current_temp1=0;
  sensors.getAddress(Termometers, 0);
  float tempC = sensors.getTempC(Termometers); // Получим температуру от датчика (или ошибку)
  if (tempC == DEVICE_DISCONNECTED) { 
    // Устройство отсоеденнено
    Serial.println("Termometer1 is DEVICE_DISCONNECTED");
    // TODO Послать бы на сервер сигнал о том, что датчит не отвечает
    
  } else {
    // Устройство отдало реальное значение температуры (или осталось старое)
   if (debug) { Serial.print("T1: ");}
    current_temp1 = tempC; // получаем температуру
    if (debug) {Serial.println(current_temp1);}
    if ((old_temperature1!=(int)current_temp1) && (current_temp1<79) && (current_temp1>5)) {
      int temp1 = (current_temp1 - (int)current_temp1) * 100; // выделяем дробную часть
      //sprintf(buf, "GET /objects/?object=SensorZal&op=m&m=tempChanged&t=%0d.%d", (int)current_temp1, abs(temp1));   
      //sendHTTPRequest();
    }
  old_temperature1=(int)current_temp1;
  }
}



//////////////////////////////////////////////////////////
void GetPower()
{
 float pause;
 float power;
 boolean LedIsOn;
 int sensorValue = 0;  
  int i=0;
  int valmin;
  
  if (debug) {Serial.println("IN GetPower");}
  LedIsOn=false; //Признач что светодиод в счетчике не горит
  boolean isOk=false;
  lastReadingTimePower = millis();
  do
  {
  // read the analog in value:
  
  sensorValue = analogRead(analogInPin);  
 // if (debug) {Serial.println(sensorValue);}     
  // map it to the range of the analog out:
if (sensorValue<80)
{
  LedIsOn=false;
  digitalWrite(ledPin, LOW);
  int valmin=sensorValue;
}
if (sensorValue>200 & LedIsOn==false)
{
 i++;
 Blink1= millis();
 digitalWrite(ledPin, HIGH);
 LedIsOn=true;
 pause=0-(Blink2-Blink1);
 power=1/(pause/3600);
 
  // print the results to the serial monitor:
  if (debug) {Serial.print("sensor = " );                       
  Serial.println(sensorValue);      
  Serial.print("Power = " );       
  Serial.println(power); 
  Serial.print("pause = " );       
  Serial.println(pause); } 
 if  (power>5) {Serial.println(valmin);}
  Blink2=Blink1;  
  if (i==3) 
  {//Корректный замер, так как первый был некорректный
  PowerOst = (power - (int)power) * 100; // выделяем дробную часть
  //    sprintf(buf, "GET /objects/?object=SensorPower&op=m&m=powerChanged&p=%0d.%d", (int)power, abs(PowerOst));   
               
 //     sendHTTPRequest();
  isOk=true;
  }
};
//Проверяем есть ли вообще расход
if (millis() - lastReadingTimePower > MaxTimeOutPower*1000) {
isOk = true;
if (debug) {Serial.println("Not power" );}  
}
  } while (!isOk);
    if (debug) {Serial.println("exit GetPower" );}   
}


void website()
{
EthernetClient client = server.available();
  if (client) {
    Serial.println("new client");
    // an http request ends with a blank line
    boolean currentLineIsBlank = true;
    while (client.connected()) {
      if (client.available()) {
        char c = client.read();
        Serial.write(c);
        // if you've gotten to the end of the line (received a newline
        // character) and the line is blank, the http request has ended,
        // so you can send a reply
        if (c == '\n' && currentLineIsBlank) {
          // send a standard http response header
          client.println("HTTP/1.1 200 OK");
          client.println("Content-Type: text/html");
          client.println("Connection: close");  // the connection will be closed after completion of the response
	  client.println("Refresh: 5");  // refresh the page automatically every 5 sec
          client.println();
          client.println("<!DOCTYPE HTML>");
          client.println("<html>");
          // output the value of each analog input pin
          ///////////////////////////////////////////
          client.println("<p>&nbsp;</p>");
              client.print("<table border=");
                     client.print((char)34);
                     client.print("0");
                     client.print((char)34);
                     client.print(" cellpadding=");
                     client.print((char)34);
                     client.print("1");
                     client.print((char)34);
                     client.print(" cellspacing=");
                     client.print((char)34);
                     client.print("1");
                     client.print((char)34);
                     client.print(" style=");
                     client.print((char)34);
                     client.print("width: 500px;");
                     client.print((char)34);
                     client.println(">");
	  client.println("<tbody>");
          client.println("<tr>");
		//client.println('<td><a href=""><img alt="" height="100" src="" width="100"></a></td>');
                     client.print("<td><a href=");
                     client.print((char)34);
                     client.print("https://dl-web.dropbox.com/get/For_Smar_House/thermometer.jpg?_subject_uid=113203227&amp;w=AACAILpYSKTtu0y7Hy6EtNDCb6QnIugbELXblPtZm3E1Jg");
                     client.print((char)34);
                     client.print("><img alt=");
                     client.print((char)34);
                     client.print((char)34);
                     client.print(" height=");
                     client.print((char)34);
                     client.print("100");
                     client.print((char)34);
                     client.print(" src=");
                     client.print((char)34);
                     client.print("https://dl-web.dropbox.com/get/For_Smar_House/thermometer.jpg?_subject_uid=113203227&amp;w=AACAILpYSKTtu0y7Hy6EtNDCb6QnIugbELXblPtZm3E1Jg");
                     client.print((char)34);
                     client.print(" width=");
                     client.print((char)34);
                     client.print("100");
                     client.print((char)34);
                     client.println("></a></td>");
		//client.println('<td><font size="7">Temp in:</font></td>');
                     client.print("<td><font size=");
                     client.print((char)34);
                     client.print("7");
                     client.print((char)34);
                     client.println(">Temp in:</font></td>");
		//client.println('<td><font size="7">23</font></td>');
                     client.print("<td><font size=");
                     client.print((char)34);
                     client.print("7");
                     client.print((char)34);
                     client.print(">");
                     client.print(tempIn);
                     client.println("</font></td>");
		client.println("</tr>");
		client.println("<tr>");
		//client.println('<td><img alt="" height="99" src="https://dl-web.dropbox.com/get/For_Smar_House/icon8-dry.jpg?_subject_uid=113203227&amp;w=AAAuWBjT_urEQtiE96fqs5uPADMu2bRaAnGTO63wL6UeWw" width="100"></td>');
                     client.print("<td><img alt=");
                     client.print((char)34);
                     client.print((char)34);
                     client.print(" height=");
                     client.print((char)34);
                     client.print("100");
                     client.print((char)34);
                     client.print(" src=");
                     client.print((char)34);
                     client.print("https://dl-web.dropbox.com/get/For_Smar_House/icon8-dry.jpg?_subject_uid=113203227&amp;w=AAAuWBjT_urEQtiE96fqs5uPADMu2bRaAnGTO63wL6UeWw");
                     client.print((char)34);
                     client.print(" width=");
                     client.print((char)34);
                     client.print("100");
                     client.print((char)34);
                     client.println("></a></td>");
              //client.println('<td><font size="7">Humidity:</font></td>');
                     client.print("<td><font size=");
                     client.print((char)34);
                     client.print("7");
                     client.print((char)34);
                     client.println(">Humidity:</font></td>");
		//client.println('<td><font size="7">11</font></td>');
                     client.print("<td><font size=");
                     client.print((char)34);
                     client.print("7");
                     client.print((char)34);
                     client.print(">");
                     client.print(hum);
                     client.println("</font></td>");
		client.println("</tr>");
		client.println("<tr>");
		//client.println('<td><img alt="" height="100" src="https://dl-web.dropbox.com/get/For_Smar_House/temp_out.png?_subject_uid=113203227&amp;w=AAAx7fzUtcjx1vGT7jpWo9sUC129ypCUgphvrRQpYYwe9g" width="100"></td>');
                     client.print("<td><img alt=");
                     client.print((char)34);
                     client.print((char)34);
                     client.print(" height=");
                     client.print((char)34);
                     client.print("100");
                     client.print((char)34);
                     client.print(" src=");
                     client.print((char)34);
                     client.print("https://dl-web.dropbox.com/get/For_Smar_House/temp_out.png?_subject_uid=113203227&amp;w=AAAx7fzUtcjx1vGT7jpWo9sUC129ypCUgphvrRQpYYwe9g");
                     client.print((char)34);
                     client.print(" width=");
                     client.print((char)34);
                     client.print("100");
                     client.print((char)34);
                     client.println("></a></td>");
		//client.println('<td><font size="7">Temp out:</font></td>');
                     client.print("<td><font size=");
                     client.print((char)34);
                     client.print("7");
                     client.print((char)34);
                     client.println(">Temp out:</font></td>");
                //client.println('<td><font size="7">22</font></td>');
                     client.print("<td><font size=");
                     client.print((char)34);
                     client.print("7");
                     client.print((char)34);
                     client.print(">");
                     client.print(current_temp1);
                     client.println("</font></td>");
		client.println("</tr>");
		client.println("<tr>");
		//client.println('<td><img alt="" height="100" src="https://dl-web.dropbox.com/get/For_Smar_House/bar.png?_subject_uid=113203227&amp;w=AACRFUeSOLIBI_9ojAPtj_nsbR7MmlKk90q6sxrl_Utxmw" width="100"></td>');
                     client.print("<td><img alt=");
                     client.print((char)34);
                     client.print((char)34);
                     client.print(" height=");
                     client.print((char)34);
                     client.print("100");
                     client.print((char)34);
                     client.print(" src=");
                     client.print((char)34);
                     client.print("https://dl-web.dropbox.com/get/For_Smar_House/bar.png?_subject_uid=113203227&amp;w=AACRFUeSOLIBI_9ojAPtj_nsbR7MmlKk90q6sxrl_Utxmw");
                     client.print((char)34);
                     client.print(" width=");
                     client.print((char)34);
                     client.print("100");
                     client.print((char)34);
                     client.println("></a></td>");
		//client.println('<td><span style="font-size: -webkit-xxx-large;">Pressure:</span></td>');
                     client.print("<td><font size=");
                     client.print((char)34);
                     client.print("7");
                     client.print((char)34);
                     client.println(">Pressure:</font></td>");
		//client.println('<td><font size="7">33</font></td>');
                     client.print("<td><font size=");
                     client.print((char)34);
                     client.print("7");
                     client.print((char)34);
                     client.print(">");
                     client.print(cur_pressure);
                     client.println("</font></td>");
		client.println("</tr>");
	client.println("</tbody>");
client.println("</table>");
client.println("<p>&nbsp;</p>");
          //////////////////////////////////////////
        break;
        }
        if (c == '\n') {
          // you're starting a new line
          currentLineIsBlank = true;
        } 
        else if (c != '\r') {
          // you've gotten a character on the current line
          currentLineIsBlank = false;
        }
      }
    }
    // give the web browser time to receive the data
    delay(1);
    // close the connection:
    client.stop();
    Serial.println("client disonnected");
  }
}


void GetTempInHum() {
  // Reading temperature or humidity takes about 250 milliseconds!
  // Sensor readings may also be up to 2 seconds 'old' (its a very slow sensor)
  hum = dht.readHumidity();
  tempIn = dht.readTemperature();

  // check if returns are valid, if they are NaN (not a number) then something went wrong!
 if (debug) { 
  if (isnan(tempIn) || isnan(hum)) {
    Serial.println("Failed to read from DHT");
  } else {
    Serial.print("Humidity: "); 
    Serial.print(hum);
    Serial.print(" %\t");
    Serial.print("Temperature: "); 
    Serial.print(tempIn);
    Serial.println(" *C");
  }
 }
}

void GetPressure() { 
  dps.getPressure(&Pressure); 
  if (debug) {   
  Serial.print("  Pressure(mm Hg):"); 
  Serial.println(Pressure/133.3);
 cur_pressure= Pressure/133.3;
  }
}

void Print(){
lcd.setCursor(0,0);

lcd.print("In: "); // print a simple message   
lcd.print(int(tempIn));
lcd.print("C ");
lcd.print("H:"); // print a simple message   
lcd.print(hum);
lcd.print("%");

lcd.setCursor(0,1);
lcd.print("Out:"); // print a simple message   
lcd.print(int(current_temp1));
lcd.print("C ");
lcd.print("P:"); // print a simple message   
lcd.print(cur_pressure);
lcd.print("mm H");
}
// ------------------------------------------------------------------------------------------------
void loop()
{
//Первый цикл - замеряем и отправляем температуру
//Второй - замеряем и отправляем потребляемую мощьность 
 //GetTemp();
 //GetPower();
// check for a reading no more than once a second.
  if (millis() - lastReadingTime > 1000){
    // if there's a reading ready, read it:
    // don't do anything until the data ready pin is high:
      GetTemp();
      GetTempInHum();
      GetPressure();
      //GetPower();
      lastReadingTime = millis();
      Print();
  }
 website();

}
